/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */
package j3d;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import javax.swing.tree.*;
import java.io.*;
import gui.*;
import javax.swing.*;
import java.awt.event.*;
/**
 * Insert the type's description here.
 *
 * @author: Yuriy Mikhaylovskiy
 */

public class _Element3 implements _Object, Serializable{
  private Canvas3D J3D;
  private PreProcessor PreP;
  public _Node node1,node2,node3,node1_tmp,node2_tmp,node3_tmp;
  public Material material = null;
  public Loads load;
  public float thickness;
  public Integer NIP=new Integer(5),PIP;
  public Float factor,friction;
  public String contact;
  public String thinning;
  public Color contur = Color.black;
  private String Id;
  public boolean selected = false;
  private String msh_name = "Contact_Triangle";
  public int msh_type = Canvas3D.MESH_Contact_Triangle;
  private JComboBox cb_type,cb_ctype,cb_mat,cb_load,cb_thin;
  private JTextField tfn1,tfn2,tfn3,tft,tffact,tffrict,tfnip,tfpip;

  public void mesh(int type, float size){}
  public boolean delete(){return selected;}

  public _Element3(_Node n1, _Node n2, _Node n3, int t, Material m, float th){
    msh_type=t;
    if(t==Canvas3D.MESH_Contact_Triangle)msh_name = "Contact_Triangle";
    else msh_name = "Shell_C0_3";
    node1=n1; node2=n2; node3=n3; material=m; thickness=th;
  }
  public _Element3(_Node n1, _Node n2, _Node n3, int t){
    this(n1,n2,n3,t,null,1);
  }
  public _Element3(_Node n1, _Node n2, _Node n3, int t, float th){
    this(n1,n2,n3,t,null,th);
  }

  private void writeObject(ObjectOutputStream out)  throws IOException{
    out.writeObject(node1);
    out.writeObject(node2);
    out.writeObject(node3);
    out.writeObject(material);
    out.writeObject(load);
    out.writeObject(contur);
    out.writeFloat(thickness);
    out.writeObject(NIP);
    out.writeObject(PIP);
    out.writeObject(factor);
    out.writeObject(friction);
    out.writeObject(contact);
    out.writeObject(thinning);
    out.writeObject(msh_name);
    out.writeInt(msh_type);
  }
  private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException{
    node1 = (_Node)in.readObject();
    node2 = (_Node)in.readObject();
    node3 = (_Node)in.readObject();
    material = (Material)in.readObject();
    load = (Loads)in.readObject();
    contur = (Color)in.readObject();
    thickness = in.readFloat();
    NIP = (Integer)in.readObject();
    PIP = (Integer)in.readObject();
    factor = (Float)in.readObject();
    friction = (Float)in.readObject();
    contact = (String)in.readObject();
    thinning = (String)in.readObject();
    selected = false;
    msh_name = (String)in.readObject();
    msh_type = in.readInt();
  }

  public Object[] get_Array(Canvas3D j3d){
    int k=0;
    Object[] arr = new Object[1+(j3d.SHOW_ID_NODE?3:0)+(j3d.SHOW_ID_ELEMENT?1:0)+((j3d.SHOW_ID_LOADS && msh_type!=Canvas3D.MESH_Contact_Triangle && load!=null)?1:0)];
    if(material==null)arr[k++]=new shpTriangle(node1.x,node1.y,node1.z,node2.x,node2.y,node2.z,node3.x,node3.y,node3.z,selected ? j3d.SELECTCOLOR : null, contur);
    else arr[k++]=new shpTriangle(node1.x,node1.y,node1.z,node2.x,node2.y,node2.z,node3.x,node3.y,node3.z,selected ? j3d.SELECTCOLOR : material.color, selected ? j3d.SELECTCOLOR : material.color);
    if(j3d.SHOW_ID_NODE){
      arr[k++]=new shpOrientedText(node1.get_Id()+"",node1.x,node1.y,node1.z,contur);
      arr[k++]=new shpOrientedText(node2.get_Id()+"",node2.x,node2.y,node2.z,contur);
      arr[k++]=new shpOrientedText(node3.get_Id()+"",node3.x,node3.y,node3.z,contur);
    }
    if(j3d.SHOW_ID_ELEMENT){
      arr[k++]=new shpOrientedText(get_Id(),(node1.x+node2.x+node3.x)/3,(node1.y+node2.y+node3.y)/3,(node1.z+node2.z+node3.z)/3,contur);
    }
    if(j3d.SHOW_ID_LOADS && msh_type!=Canvas3D.MESH_Contact_Triangle && load!=null) arr[k++]=new shpOrientedText(load.name,(node1.x+node2.x+node3.x)/3,(node1.y+node2.y+node3.y)/3,(node1.z+node2.z+node3.z)/3,load.color);
    return arr;
  }
  public String get_Id(){
    return Id;
  }
  public void set_Id(String id){
    Id=id;
  }
  public boolean isSelected(){return selected;}
  public void Select(String st){ selected=st!=null; }
  public String toString(){ return msh_name+" ID="+Id;}
  public MutableTreeNode get_TreeNode(){
    DefaultMutableTreeNode node = new DefaultMutableTreeNode(this);
    node.add(node1.get_TreeNode());
    node.add(node2.get_TreeNode());
    node.add(node3.get_TreeNode());
    if(msh_type==Canvas3D.MESH_Shell_C0_3)node.add(new DefaultMutableTreeNode("Material - "+material.name));
    node.add(new DefaultMutableTreeNode("Thickness - "+thickness));
    node.add(new DefaultMutableTreeNode("Factor - "+(factor!=null?factor+"":"Default")));
    node.add(new DefaultMutableTreeNode("Friction - "+friction));
    if(msh_type==Canvas3D.MESH_Shell_C0_3){
      node.add(new DefaultMutableTreeNode("Contact - "+(contact!=null?contact+"":"Default")));
      node.add(new DefaultMutableTreeNode("Load - "+load));
      node.add(new DefaultMutableTreeNode("NIP - "+NIP));
      node.add(new DefaultMutableTreeNode("PIP - "+PIP));
      node.add(new DefaultMutableTreeNode("Thinning - "+(thinning!=null?thinning+"":"Default")));
    }
    return node;
  }
  public void transform3D(Matrix3D t){
    if(!selected)return;
    node1.Select("");
    node2.Select("");
    node3.Select("");
    node1.transform3D(t);
    node2.transform3D(t);
    node3.transform3D(t);
    node1.Select(null);
    node2.Select(null);
    node3.Select(null);
  }
  public void error(Object st){
    JOptionPane.showMessageDialog(null,"Error: "+st,"Error!",JOptionPane.ERROR_MESSAGE);
    System.out.println("Error: "+st);
    if(st instanceof Exception) ((Exception)st).printStackTrace();
  }

  public JPanel getEditPanel(Canvas3D j3d, PreProcessor pp){
    J3D=j3d;
    PreP = pp;
    JPanel p = new JPanel(new BorderLayout());
    JPanel p1 = new JPanel(new GridLayout(3,3));
    JPanel p3 = new JPanel();
    JPanel p2 = new JPanel(new GridLayout(9,1));
    JPanel p4 = new JPanel(new BorderLayout());
    JPanel p5 = new JPanel(new BorderLayout());
    JPanel p6 = new JPanel(new BorderLayout());
    JPanel p7 = new JPanel(new BorderLayout());
    JPanel p8 = new JPanel(new BorderLayout());
    JPanel p9 = new JPanel(new BorderLayout());
    JPanel p10 = new JPanel(new BorderLayout());
    JPanel p11 = new JPanel(new BorderLayout());
    JPanel p12 = new JPanel(new BorderLayout());
    JPanel p13 = new JPanel(new BorderLayout());
    JPanel p14 = new JPanel(new BorderLayout());
    node1_tmp=node1;
    node2_tmp=node2;
    node3_tmp=node3;
    String[] type = {"Contact_Triangle","Shell_C0_3"};
    String[] ctype = {"","EDGE","OFF"};
    String[] ttype = {"","ON","OFF"};
    cb_mat = new JComboBox();
    cb_type = new JComboBox(type);
    cb_ctype = new JComboBox(ctype);
    cb_load = new JComboBox();
    cb_thin = new JComboBox(ttype);
    cb_load.addItem("");
    for(Enumeration en = PreP.LoadDB.keys(); en.hasMoreElements();)  cb_load.addItem(en.nextElement());
    if(load!=null)cb_load.setSelectedItem(load.name);
    if(contact!=null)cb_ctype.setSelectedItem(contact);
    if(thinning!=null)cb_thin.setSelectedItem(thinning);
    tfn1 = new JTextField(node1+"",3);
    tfn2 = new JTextField(node2+"",3);
    tfn3 = new JTextField(node3+"",3);
    tft = new JTextField(thickness+"");
    tffact = new JTextField(factor!=null?factor+"":"");
    tffrict = new JTextField(friction!=null?friction+"":"");
    tfnip = new JTextField(NIP!=null?NIP+"":"");
    tfpip = new JTextField(PIP!=null?PIP+"":"");
    tfn1.setEditable(false);
    tfn2.setEditable(false);
    tfn3.setEditable(false);
    JButton b_1 = new JButton("<<");
    b_1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try{
          Object obj = J3D.getSelectedObject3D();
          if(obj!=null && obj instanceof _Node){
            node1_tmp=(_Node)obj;
            tfn1.setText(obj.toString());
          }else{
            node1_tmp=null;
            tfn1.setText("");
          }
        }catch(Exception e1) { error(e1);}
      }
    });
    JButton b_2 = new JButton("<<");
    b_2.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try{
          Object obj = J3D.getSelectedObject3D();
          if(obj!=null && obj instanceof _Node){
            node2_tmp=(_Node)obj;
            tfn2.setText(obj.toString());
          }else{
            node2_tmp=null;
            tfn2.setText("");
          }
        }catch(Exception e1) { error(e1);}
      }
    });
    JButton b_3 = new JButton("<<");
    b_3.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try{
          Object obj = J3D.getSelectedObject3D();
          if(obj!=null && obj instanceof _Node){
            node3_tmp=(_Node)obj;
            tfn3.setText(obj.toString());
          }else{
            node3_tmp=null;
            tfn3.setText("");
          }
        }catch(Exception e1) { error(e1);}
      }
    });
    JButton b_upd = new JButton("Update");
    b_upd.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try{
          if(node1_tmp==null || node2_tmp==null || node3_tmp==null){error("Node = null!"); return;}
          float thickness_tmp = Float.parseFloat(tft.getText());
          Float factor_tmp=tffact.getText().trim().length()==0?null:new Float(tffact.getText());
          Float friction_tmp=tffrict.getText().trim().length()==0?null:new Float(tffrict.getText());
          Integer NIP_tmp=tfnip.getText().trim().length()==0?null:new Integer(tfnip.getText());
          Integer PIP_tmp=tfpip.getText().trim().length()==0?null:new Integer(tfpip.getText());
          node1=node1_tmp;
          node2=node2_tmp;
          node3=node3_tmp;
          msh_name=cb_type.getSelectedItem()+"";
          material = (Material)PreP.MatDB.get(cb_mat.getSelectedItem()+"");
          if(cb_type.getSelectedIndex()==0) msh_type = Canvas3D.MESH_Contact_Triangle; else msh_type = Canvas3D.MESH_Shell_C0_3;
          contact=(cb_ctype.getSelectedItem()+"").length()==0?null:cb_ctype.getSelectedItem()+"";
          thinning=(cb_thin.getSelectedItem()+"").length()==0?null:cb_thin.getSelectedItem()+"";
          load = (cb_load.getSelectedItem()+"").length()==0?null:(Loads)PreP.LoadDB.get(cb_load.getSelectedItem()+"");
          thickness=thickness_tmp;
          friction=friction_tmp;
          factor=factor_tmp;
          NIP=NIP_tmp;
          PIP=PIP_tmp;
          J3D.tree_reset();
          J3D.view_reset();
        }catch(Exception e1) { error(e1);}
      }
    });
    cb_type.setForeground(Color.blue);
    p.add(p1, BorderLayout.CENTER);
    p1.add(new JLabel("Node 1"));
    p1.add(tfn1);
    p1.add(b_1);
    p1.add(new JLabel("Node 2"));
    p1.add(tfn2);
    p1.add(b_2);
    p1.add(new JLabel("Node 3"));
    p1.add(tfn3);
    p1.add(b_3);
    JLabel lb1 = new JLabel("Edit - ");
    JLabel lb2 = new JLabel(" ID="+Id);
    lb1.setForeground(Color.blue);
    lb2.setForeground(Color.blue);
    p.add(p6, BorderLayout.NORTH);
    p6.add(cb_type, BorderLayout.CENTER);
    p6.add(lb1, BorderLayout.WEST);
    p6.add(lb2, BorderLayout.EAST);
    p.add(p10,  BorderLayout.SOUTH);
    p10.add(p2,  BorderLayout.CENTER);
    p2.add(p4);
    p4.add(new JLabel("Material"), BorderLayout.WEST);
    p4.add(cb_mat, BorderLayout.CENTER);
    p2.add(p5);
    p5.add(new JLabel("Thickness"), BorderLayout.WEST);
    p5.add(tft, BorderLayout.CENTER);
    p2.add(p7);
    p7.add(new JLabel("Factor"), BorderLayout.WEST);
    p7.add(tffact, BorderLayout.CENTER);
    p2.add(p8);
    p8.add(new JLabel("Friction"), BorderLayout.WEST);
    p8.add(tffrict, BorderLayout.CENTER);
    p2.add(p9);
    p9.add(new JLabel("Contact"), BorderLayout.WEST);
    p9.add(cb_ctype, BorderLayout.CENTER);
    p10.add(p3,BorderLayout.SOUTH);
    p2.add(p11);
    p11.add(new JLabel("Load"), BorderLayout.WEST);
    p11.add(cb_load, BorderLayout.CENTER);
    p2.add(p12);
    p12.add(new JLabel("NIP"), BorderLayout.WEST);
    p12.add(tfnip, BorderLayout.CENTER);
    p2.add(p13);
    p13.add(new JLabel("PIP"), BorderLayout.WEST);
    p13.add(tfpip, BorderLayout.CENTER);
    p2.add(p14);
    p14.add(new JLabel("Thinning"), BorderLayout.WEST);
    p14.add(cb_thin, BorderLayout.CENTER);
    p3.add(b_upd);
    for(Enumeration en = PreP.MatDB.keys(); en.hasMoreElements();)  cb_mat.addItem(en.nextElement());
    cb_mat.setSelectedItem(material.name);
    cb_type.setSelectedItem(msh_name);
    cb_type.addItemListener(new ItemListener(){
      public void itemStateChanged(ItemEvent e){
        if((cb_type.getSelectedItem()+"").indexOf("Contact_Triangle")!=-1){
          cb_mat.setEnabled(false);
          cb_ctype.setEnabled(false);
          cb_load.setEnabled(false);
          tfnip.setEnabled(false);
          tfpip.setEnabled(false);
          cb_thin.setEnabled(false);
        }else{
          cb_mat.setEnabled(true);
          cb_ctype.setEnabled(true);
          cb_load.setEnabled(true);
          tfnip.setEnabled(true);
          tfpip.setEnabled(true);
          cb_thin.setEnabled(true);
        }
      }
    });
    if((cb_type.getSelectedItem()+"").indexOf("Contact_Triangle")!=-1){
      cb_mat.setEnabled(false);
      cb_ctype.setEnabled(false);
      cb_load.setEnabled(false);
      tfnip.setEnabled(false);
      tfpip.setEnabled(false);
      cb_thin.setEnabled(false);
    }else{
      cb_mat.setEnabled(true);
      cb_ctype.setEnabled(true);
      cb_load.setEnabled(true);
      tfnip.setEnabled(true);
      tfpip.setEnabled(true);
      cb_thin.setEnabled(true);
    }
    p.validate();
    return p;
  }


  public _Node[] get_Nodes(){
    _Node[] arr = {node1,node2,node3};
    return arr;
  }
  public _Object[] get_Elements(){
    _Object[] arr = {this};
    return arr;
  }
}